library(coin)

setwd("C:\\varmechanisms")
d = read.csv("results-coded.csv")


# RQ1: Correctness

library(ggplot2)
library(scales)
library(plyr)

ann1 <- data.frame(d$ann1)
ann1 <- data.frame(gather(ann1,"dc","correct"),"code"="A","page"="Task 1")
ann2 <- data.frame(d$ann2)
ann2 <- data.frame(gather(ann2,"dc","correct"),"code"="A","page"="Task 2")
ann3 <- data.frame(d$ann3)
ann3 <- data.frame(gather(ann3,"dc","correct"),"code"="A","page"="Task 3")
ann4 <- data.frame(d$ann4)
ann4 <- data.frame(gather(ann4,"dc","correct"),"code"="A","page"="Task 4")
ann5 <- data.frame(d$ann5)
ann5 <- data.frame(gather(ann5,"dc","correct"),"code"="A","page"="Task 5")
ann6 <- data.frame(d$ann6)
ann6 <- data.frame(gather(ann6,"dc","correct"),"code"="A","page"="Task 6")
com1 <- data.frame(d$com1)
com1 <- data.frame(gather(com1,"dc","correct"),"code"="C","page"="Task 1")
com2 <- data.frame(d$com2)
com2 <- data.frame(gather(com2,"dc","correct"),"code"="C","page"="Task 2")
com3 <- data.frame(d$com3)
com3 <- data.frame(gather(com3,"dc","correct"),"code"="C","page"="Task 3")
com4 <- data.frame(d$com4)
com4 <- data.frame(gather(com4,"dc","correct"),"code"="C","page"="Task 4")
com5 <- data.frame(d$com5)
com5 <- data.frame(gather(com5,"dc","correct"),"code"="C","page"="Task 5")
com6 <- data.frame(d$com6)
com6 <- data.frame(gather(com6,"dc","correct"),"code"="C","page"="Task 6")
enu1 <- data.frame(d$enu1)
enu1 <- data.frame(gather(enu1,"dc","correct"),"code"="E","page"="Task 1")
enu2 <- data.frame(d$enu2)
enu2 <- data.frame(gather(enu2,"dc","correct"),"code"="E","page"="Task 2")
enu3 <- data.frame(d$enu3)
enu3 <- data.frame(gather(enu3,"dc","correct"),"code"="E","page"="Task 3")
enu4 <- data.frame(d$enu4)
enu4 <- data.frame(gather(enu4,"dc","correct"),"code"="E","page"="Task 4")
enu5 <- data.frame(d$enu5)
enu5 <- data.frame(gather(enu5,"dc","correct"),"code"="E","page"="Task 5")
enu6 <- data.frame(d$enu6)
enu6 <- data.frame(gather(enu6,"dc","correct"),"code"="E","page"="Task 6")
data_corr  <- rbind(ann1,ann2,ann3,ann4,ann5,ann6,com1,com2,com3,com4,com5,com6,enu1,enu2,enu3,enu4,enu5,enu6)
data_corr$correct <- factor(data_corr$correct, levels=c("1", "0.5", "0"))

# 9:5
plot <- ggplot(data_corr, aes(code, fill=correct)) +
  geom_bar(color="black", size=0.25, position = "fill") +
#  geom_bar(color="black", size=0.25) +
  facet_grid(. ~ page) +
  theme_bw(base_size = 12, base_family="Arial") +
  scale_fill_manual(name="", labels=c(" Correct   ", " Partially correct    ", " Incorrect"), values=c("#fef0d9", "#fdcc8a", "#d7301f")) +
#  geom_text(stat = "count", aes(label = ..count..), position=position_stack(vjust=.5), size=3.5) +
  geom_text(stat = "count", aes(label = ..count..), position=position_fill(vjust=.5), size=3.5) +
  theme(legend.position="bottom",
        legend.title=element_blank(),
        legend.background=element_blank(),
        panel.background=element_blank(),
        panel.border=element_rect(colour="black", fill=NA, size=0.1),
        panel.grid.major=element_blank(),
        panel.grid.minor=element_blank(),
        strip.background = element_blank(),
        strip.text.y = element_text(margin = margin(l = 2))) +
  labs(x = "Group", y = "Responses")
plot


# RQ1: Time

dev.new(width=4, height=2)
library("ggplot2")
library("dplyr")
library("grid") 

reload()

tann <- d[,c("timeann"),drop=FALSE]
colnames(tann)[1] <- "time"
tann$group = "A"
tcom <- d[,c("timecom"),drop=FALSE]
colnames(tcom)[1] <- "time"
tcom$group = "C"
tenu <- d[,c("timeenu"),drop=FALSE]
colnames(tenu)[1] <- "time"
tenu$group = "E"
total <- rbind(tann,tcom,tenu)
total <- total[complete.cases(total),]

scaleFUN <- function(x) sprintf("%.1f", x)
maxval <- 19
total$group <- factor(total$group, levels = c('E', 'C', 'A'), ordered = TRUE)
p <- ggplot(total, aes(group,time)) +
  xlab(" ") +
  ylab(" ") +
   coord_flip()
filtered <- total %>% filter(time>maxval) %>%
	group_by(group) %>%
	summarise(outlier_txt=paste(time,collapse=","))	
p2 <- p + geom_boxplot() +
	scale_y_continuous(labels=scaleFUN, limits=c(min(total$time),maxval))
	
p2



# RQ2: Subjective ratings


library("likert")
dev.new(width=3, height=3)

dann <- d[,c("undann","diff12ann","diff34ann", "diff56ann")]
colnames(dann)[1] <- "und"
colnames(dann)[2] <- "diff12"
colnames(dann)[3] <- "diff34"
colnames(dann)[4] <- "diff56"
dann$group = "Annotative"
dcom <- d[,c("undcom","diff12com","diff34com", "diff56com")]
colnames(dcom)[1] <- "und"
colnames(dcom)[2] <- "diff12"
colnames(dcom)[3] <- "diff34"
colnames(dcom)[4] <- "diff56"
dcom$group = "Compositional"
denu <- d[,c("undenu","diff12enu","diff34enu", "diff56enu")]
colnames(denu)[1] <- "und"
colnames(denu)[2] <- "diff12"
colnames(denu)[3] <- "diff34"
colnames(denu)[4] <- "diff56"
denu$group = "Enumerative"
total <- rbind(dann,dcom,denu)


easyToHard5List <- list("Very easy"=1,"Easy"=2,"Neutral"=3,"Hard"=4,"Very Hard"=5)
easyToHard5 <- c("1","2","3","4","5")
questions <- c("1. How easy did you find it to understand each mechanism?", 
                          "2. How difficult was it to answer the questions on task type 1 for each mechanism?",
                          "3. How difficult was it to answer the questions on task type 2 for each mechanism?",
                          "4. How difficult was it to answer the questions on task type 3 for each mechanism?", "group")
tdata <- total
tdata$group = factor(tdata$group, levels = c("Enumerative","Compositional","Annotative"), ordered = TRUE)
tdata$und = factor(tdata$und, levels = easyToHard5, ordered = TRUE)
tdata$diff12 = factor(tdata$diff12,levels = easyToHard5, ordered = TRUE)
tdata$diff34 = factor(tdata$diff34,levels = easyToHard5, ordered = TRUE)
tdata$diff56 = factor(tdata$diff56,levels = easyToHard5, ordered = TRUE)
levels(tdata$group) <- list(E="Enumerative", C="Compositional", A="Annotative")
levels(tdata$und) <- easyToHard5List
levels(tdata$diff12) <- easyToHard5List
levels(tdata$diff34) <- easyToHard5List
levels(tdata$diff56) <- easyToHard5List
names(tdata) <- questions
names(tdata) = factor(names(tdata), levels=questions, ordered=TRUE)				  

ltdata <- likert(items=tdata[,1:4], grouping = tdata[,5])
plot(ltdata) + theme(legend.text=element_text(size=7)) 


# plot(ltdata)
# pdf("subj.pdf",width=7,height=4,paper='special')
# plot(ltdata,  group.order=total$group)
 plot(ltdata)
# dev.off()


n=100
fdaff_likert <- data.frame(
    country=factor(sample(1:3, n, replace=T), labels=c("Annotative","Mexico","Canada")), 
    item1=factor(sample(1:5,n, replace=T), labels=c("Very easy","Easy","Neutral","Hard","Very Hard"))
    item2=factor(sample(1:5,n, replace=T), labels=c("Very easy","Easy","Neutral","Hard","Very Hard")),
    item3=factor(sample(1:5,n, replace=T), labels=c("Very easy","Easy","Neutral","Hard","Very Hard")),
    item4=factor(sample(1:5,n, replace=T), labels=c("Very easy","Easy","Neutral","Hard","Very Hard")),
)
fdaff_likert3 <- likert(items=fdaff_likert[,2:4], grouping=fdaff_likert[,1])
plot(fdaff_likert3)



# RQ3: Preference

pref<-d[,c(29,30,31)]
pref[,1] <- factor(pref[,1],levels=c("ann","com","enu","none"), ordered = TRUE)
pref[,2] <- factor(pref[,2],levels=c("ann","com","enu","none"), ordered = TRUE)
pref[,3] <- factor(pref[,3],levels=c("ann","com","enu","none"), ordered = TRUE)
levels(pref[,1]) <- list("Enumerative"="enu", "Compositional"="com", "Annotative"="ann", "None"="none")
levels(pref[,2]) <- list("Enumerative"="enu", "Compositional"="com", "Annotative"="ann", "None"="none")
levels(pref[,3]) <- list("Enumerative"="enu", "Compositional"="com", "Annotative"="ann", "None"="none")
freq=table(col(pref), as.matrix(pref)) 
freq=(freq*100)/nrow(d)

Tasks=c("Task type 1","Task type 2","Task type 3")     # create list of names
data=data.frame(cbind(freq),Tasks)   # combine them into a data frame

# melt the data frame for plotting
data.m <- melt(data, id.vars='Tasks')
colnames(data.m) <- c("Tasks","Mechanism","Percentage")

# plot everything
ggplot(data.m, aes(Tasks, Percentage)) +   
  geom_bar(aes(fill = Mechanism), position = "dodge", stat="identity")
  
